-- 加载lua-engine
JassRuntime = require("jass.runtime")
JassConsole = require("jass.console")
JassDebug = require("jass.debug")
JassCommon = require("jass.common")
JassGlobals = require("jass.globals")
JassSlk = require("jass.slk")
JassJapi = require("jass.japi")
JassHook = require("jass.hook")

-- 自定义J
J = {}
J.handleRef = function(h) JassDebug["handle_ref"](h) end
J.handleUnRef = function(h) JassDebug["handle_unref"](h) end
J.handleMax = function() return JassDebug["handlemax"]() end
J.handleDef = function(...) return JassDebug["handledef"](...) end
J.ExecJAPI = function(method, ...) print(method) end
J.AbilityId = JassCommon["AbilityId"]
J.AbilityId2String = JassCommon["AbilityId2String"]
J.Acos = JassCommon["Acos"]
J.AddHeroXP = JassCommon["AddHeroXP"]
J.AddIndicator = JassCommon["AddIndicator"]
J.AddItemToAllStock = JassCommon["AddItemToAllStock"]
J.AddItemToStock = JassCommon["AddItemToStock"]
J.AddLightning = JassCommon["AddLightning"]
J.AddLightningEx = JassCommon["AddLightningEx"]
J.AddPlayerTechResearched = JassCommon["AddPlayerTechResearched"]
J.AddResourceAmount = JassCommon["AddResourceAmount"]
J.AddSpecialEffect = JassCommon["AddSpecialEffect"]
J.AddSpecialEffectLoc = JassCommon["AddSpecialEffectLoc"]
J.AddSpecialEffectTarget = JassCommon["AddSpecialEffectTarget"]
J.AddSpellEffect = JassCommon["AddSpellEffect"]
J.AddSpellEffectById = JassCommon["AddSpellEffectById"]
J.AddSpellEffectByIdLoc = JassCommon["AddSpellEffectByIdLoc"]
J.AddSpellEffectLoc = JassCommon["AddSpellEffectLoc"]
J.AddSpellEffectTarget = JassCommon["AddSpellEffectTarget"]
J.AddSpellEffectTargetById = JassCommon["AddSpellEffectTargetById"]
J.AddUnitAnimationProperties = JassCommon["AddUnitAnimationProperties"]
J.AddUnitToAllStock = JassCommon["AddUnitToAllStock"]
J.AddUnitToStock = JassCommon["AddUnitToStock"]
J.AddWeatherEffect = JassCommon["AddWeatherEffect"]
J.AdjustCameraField = JassCommon["AdjustCameraField"]
J.And = JassCommon["And"]
J.Asin = JassCommon["Asin"]
J.Atan = JassCommon["Atan"]
J.Atan2 = JassCommon["Atan2"]
J.AttachSoundToUnit = JassCommon["AttachSoundToUnit"]
J.CachePlayerHeroData = JassCommon["CachePlayerHeroData"]
J.CameraSetSmoothingFactor = JassCommon["CameraSetSmoothingFactor"]
J.CameraSetSourceNoise = JassCommon["CameraSetSourceNoise"]
J.CameraSetSourceNoiseEx = JassCommon["CameraSetSourceNoiseEx"]
J.CameraSetTargetNoise = JassCommon["CameraSetTargetNoise"]
J.CameraSetTargetNoiseEx = JassCommon["CameraSetTargetNoiseEx"]
J.CameraSetupApply = JassCommon["CameraSetupApply"]
J.CameraSetupApplyForceDuration = JassCommon["CameraSetupApplyForceDuration"]
J.CameraSetupApplyForceDurationWithZ = JassCommon["CameraSetupApplyForceDurationWithZ"]
J.CameraSetupApplyWithZ = JassCommon["CameraSetupApplyWithZ"]
J.CameraSetupGetDestPositionLoc = JassCommon["CameraSetupGetDestPositionLoc"]
J.CameraSetupGetDestPositionX = JassCommon["CameraSetupGetDestPositionX"]
J.CameraSetupGetDestPositionY = JassCommon["CameraSetupGetDestPositionY"]
J.CameraSetupGetField = JassCommon["CameraSetupGetField"]
J.CameraSetupSetDestPosition = JassCommon["CameraSetupSetDestPosition"]
J.CameraSetupSetField = JassCommon["CameraSetupSetField"]
J.ChangeLevel = JassCommon["ChangeLevel"]
J.Cheat = JassCommon["Cheat"]
J.ChooseRandomCreep = JassCommon["ChooseRandomCreep"]
J.ChooseRandomItem = JassCommon["ChooseRandomItem"]
J.ChooseRandomItemEx = JassCommon["ChooseRandomItemEx"]
J.ChooseRandomNPBuilding = JassCommon["ChooseRandomNPBuilding"]
J.ClearMapMusic = JassCommon["ClearMapMusic"]
J.ClearSelection = JassCommon["ClearSelection"]
J.ClearTextMessages = JassCommon["ClearTextMessages"]
J.CommandAI = JassCommon["CommandAI"]
J.Condition = JassCommon["Condition"]
J.ConvertAIDifficulty = JassCommon["ConvertAIDifficulty"]
J.ConvertAllianceType = JassCommon["ConvertAllianceType"]
J.ConvertAttackType = JassCommon["ConvertAttackType"]
J.ConvertBlendMode = JassCommon["ConvertBlendMode"]
J.ConvertCameraField = JassCommon["ConvertCameraField"]
J.ConvertDamageType = JassCommon["ConvertDamageType"]
J.ConvertDialogEvent = JassCommon["ConvertDialogEvent"]
J.ConvertEffectType = JassCommon["ConvertEffectType"]
J.ConvertFGameState = JassCommon["ConvertFGameState"]
J.ConvertFogState = JassCommon["ConvertFogState"]
J.ConvertGameDifficulty = JassCommon["ConvertGameDifficulty"]
J.ConvertGameEvent = JassCommon["ConvertGameEvent"]
J.ConvertGameSpeed = JassCommon["ConvertGameSpeed"]
J.ConvertGameType = JassCommon["ConvertGameType"]
J.ConvertIGameState = JassCommon["ConvertIGameState"]
J.ConvertItemType = JassCommon["ConvertItemType"]
J.ConvertLimitOp = JassCommon["ConvertLimitOp"]
J.ConvertMapControl = JassCommon["ConvertMapControl"]
J.ConvertMapDensity = JassCommon["ConvertMapDensity"]
J.ConvertMapFlag = JassCommon["ConvertMapFlag"]
J.ConvertMapSetting = JassCommon["ConvertMapSetting"]
J.ConvertMapVisibility = JassCommon["ConvertMapVisibility"]
J.ConvertPathingType = JassCommon["ConvertPathingType"]
J.ConvertPlacement = JassCommon["ConvertPlacement"]
J.ConvertPlayerColor = JassCommon["ConvertPlayerColor"]
J.ConvertPlayerEvent = JassCommon["ConvertPlayerEvent"]
J.ConvertPlayerGameResult = JassCommon["ConvertPlayerGameResult"]
J.ConvertPlayerScore = JassCommon["ConvertPlayerScore"]
J.ConvertPlayerSlotState = JassCommon["ConvertPlayerSlotState"]
J.ConvertPlayerState = JassCommon["ConvertPlayerState"]
J.ConvertPlayerUnitEvent = JassCommon["ConvertPlayerUnitEvent"]
J.ConvertRace = JassCommon["ConvertRace"]
J.ConvertRacePref = JassCommon["ConvertRacePref"]
J.ConvertRarityControl = JassCommon["ConvertRarityControl"]
J.ConvertSoundType = JassCommon["ConvertSoundType"]
J.ConvertStartLocPrio = JassCommon["ConvertStartLocPrio"]
J.ConvertTexMapFlags = JassCommon["ConvertTexMapFlags"]
J.ConvertUnitEvent = JassCommon["ConvertUnitEvent"]
J.ConvertUnitState = JassCommon["ConvertUnitState"]
J.ConvertUnitType = JassCommon["ConvertUnitType"]
J.ConvertVersion = JassCommon["ConvertVersion"]
J.ConvertVolumeGroup = JassCommon["ConvertVolumeGroup"]
J.ConvertWeaponType = JassCommon["ConvertWeaponType"]
J.ConvertWidgetEvent = JassCommon["ConvertWidgetEvent"]
J.CopySaveGame = JassCommon["CopySaveGame"]
J.Cos = JassCommon["Cos"]
J.CreateBlightedGoldmine = JassCommon["CreateBlightedGoldmine"]
J.CreateCameraSetup = JassCommon["CreateCameraSetup"]
J.CreateCorpse = JassCommon["CreateCorpse"]
J.CreateDeadDestructable = JassCommon["CreateDeadDestructable"]
J.CreateDeadDestructableZ = JassCommon["CreateDeadDestructableZ"]
J.CreateDefeatCondition = JassCommon["CreateDefeatCondition"]
J.CreateDestructable = JassCommon["CreateDestructable"]
J.CreateDestructableZ = JassCommon["CreateDestructableZ"]
J.CreateFogModifierRadius = JassCommon["CreateFogModifierRadius"]
J.CreateFogModifierRadiusLoc = JassCommon["CreateFogModifierRadiusLoc"]
J.CreateFogModifierRect = JassCommon["CreateFogModifierRect"]
J.CreateForce = JassCommon["CreateForce"]
J.CreateGroup = JassCommon["CreateGroup"]
J.CreateImage = JassCommon["CreateImage"]
J.CreateItem = JassCommon["CreateItem"]
J.CreateItemPool = JassCommon["CreateItemPool"]
J.CreateLeaderboard = JassCommon["CreateLeaderboard"]
J.CreateMIDISound = JassCommon["CreateMIDISound"]
J.CreateMultiboard = JassCommon["CreateMultiboard"]
J.CreateQuest = JassCommon["CreateQuest"]
J.CreateRegion = JassCommon["CreateRegion"]
J.CreateSound = JassCommon["CreateSound"]
J.CreateSoundFilenameWithLabel = JassCommon["CreateSoundFilenameWithLabel"]
J.CreateSoundFromLabel = JassCommon["CreateSoundFromLabel"]
J.CreateTextTag = JassCommon["CreateTextTag"]
J.CreateTimer = JassCommon["CreateTimer"]
J.CreateTimerDialog = JassCommon["CreateTimerDialog"]
J.CreateTrackable = JassCommon["CreateTrackable"]
J.CreateTrigger = JassCommon["CreateTrigger"]
J.CreateUbersplat = JassCommon["CreateUbersplat"]
J.CreateUnit = JassCommon["CreateUnit"]
J.CreateUnitAtLoc = JassCommon["CreateUnitAtLoc"]
J.CreateUnitAtLocByName = JassCommon["CreateUnitAtLocByName"]
J.CreateUnitByName = JassCommon["CreateUnitByName"]
J.CreateUnitPool = JassCommon["CreateUnitPool"]
J.CripplePlayer = JassCommon["CripplePlayer"]
J.DecUnitAbilityLevel = JassCommon["DecUnitAbilityLevel"]
J.DefeatConditionSetDescription = JassCommon["DefeatConditionSetDescription"]
J.DefineStartLocation = JassCommon["DefineStartLocation"]
J.DefineStartLocationLoc = JassCommon["DefineStartLocationLoc"]
J.Deg2Rad = JassCommon["Deg2Rad"]
J.DestroyBoolExpr = JassCommon["DestroyBoolExpr"]
J.DestroyCondition = JassCommon["DestroyCondition"]
J.DestroyDefeatCondition = JassCommon["DestroyDefeatCondition"]
J.DestroyEffect = JassCommon["DestroyEffect"]
J.DestroyFilter = JassCommon["DestroyFilter"]
J.DestroyFogModifier = JassCommon["DestroyFogModifier"]
J.DestroyForce = JassCommon["DestroyForce"]
J.DestroyGroup = JassCommon["DestroyGroup"]
J.DestroyImage = JassCommon["DestroyImage"]
J.DestroyItemPool = JassCommon["DestroyItemPool"]
J.DestroyLeaderboard = JassCommon["DestroyLeaderboard"]
J.DestroyLightning = JassCommon["DestroyLightning"]
J.DestroyMultiboard = JassCommon["DestroyMultiboard"]
J.DestroyQuest = JassCommon["DestroyQuest"]
J.DestroyTextTag = JassCommon["DestroyTextTag"]
J.DestroyTimer = JassCommon["DestroyTimer"]
J.DestroyTimerDialog = JassCommon["DestroyTimerDialog"]
J.DestroyTrigger = JassCommon["DestroyTrigger"]
J.DestroyUbersplat = JassCommon["DestroyUbersplat"]
J.DestroyUnitPool = JassCommon["DestroyUnitPool"]
J.DestructableRestoreLife = JassCommon["DestructableRestoreLife"]
J.DialogAddButton = JassCommon["DialogAddButton"]
J.DialogAddQuitButton = JassCommon["DialogAddQuitButton"]
J.DialogClear = JassCommon["DialogClear"]
J.DialogCreate = JassCommon["DialogCreate"]
J.DialogDestroy = JassCommon["DialogDestroy"]
J.DialogDisplay = JassCommon["DialogDisplay"]
J.DialogSetMessage = JassCommon["DialogSetMessage"]
J.DisableRestartMission = JassCommon["DisableRestartMission"]
J.DisableTrigger = JassCommon["DisableTrigger"]
J.DisplayCineFilter = JassCommon["DisplayCineFilter"]
J.DisplayLoadDialog = JassCommon["DisplayLoadDialog"]
J.DisplayTextToPlayer = JassCommon["DisplayTextToPlayer"]
J.DisplayTimedTextFromPlayer = JassCommon["DisplayTimedTextFromPlayer"]
J.DisplayTimedTextToPlayer = JassCommon["DisplayTimedTextToPlayer"]
J.DoNotSaveReplay = JassCommon["DoNotSaveReplay"]
J.EnableDragSelect = JassCommon["EnableDragSelect"]
J.EnableMinimapFilterButtons = JassCommon["EnableMinimapFilterButtons"]
J.EnableOcclusion = JassCommon["EnableOcclusion"]
J.EnablePreSelect = JassCommon["EnablePreSelect"]
J.EnableSelect = JassCommon["EnableSelect"]
J.EnableTrigger = JassCommon["EnableTrigger"]
J.EnableUserControl = JassCommon["EnableUserControl"]
J.EnableUserUI = JassCommon["EnableUserUI"]
J.EnableWeatherEffect = JassCommon["EnableWeatherEffect"]
J.EnableWorldFogBoundary = JassCommon["EnableWorldFogBoundary"]
J.EndCinematicScene = JassCommon["EndCinematicScene"]
J.EndGame = JassCommon["EndGame"]
J.EndThematicMusic = JassCommon["EndThematicMusic"]
J.EnumDestructablesInRect = JassCommon["EnumDestructablesInRect"]
J.EnumItemsInRect = JassCommon["EnumItemsInRect"]
J.EmptyFunc = function() end
J.ExecuteFunc = JassCommon["ExecuteFunc"]
J.Filter = JassCommon["Filter"]
J.FinishUbersplat = JassCommon["FinishUbersplat"]
J.FirstOfGroup = JassCommon["FirstOfGroup"]
J.FlashQuestDialogButton = JassCommon["FlashQuestDialogButton"]
J.FlushChildHashtable = JassCommon["FlushChildHashtable"]
J.FlushGameCache = JassCommon["FlushGameCache"]
J.FlushParentHashtable = JassCommon["FlushParentHashtable"]
J.FlushStoredBoolean = JassCommon["FlushStoredBoolean"]
J.FlushStoredInteger = JassCommon["FlushStoredInteger"]
J.FlushStoredMission = JassCommon["FlushStoredMission"]
J.FlushStoredReal = JassCommon["FlushStoredReal"]
J.FlushStoredString = JassCommon["FlushStoredString"]
J.FlushStoredUnit = JassCommon["FlushStoredUnit"]
J.FogEnable = JassCommon["FogEnable"]
J.FogMaskEnable = JassCommon["FogMaskEnable"]
J.FogModifierStart = JassCommon["FogModifierStart"]
J.FogModifierStop = JassCommon["FogModifierStop"]
J.ForForce = JassCommon["ForForce"]
J.ForGroup = JassCommon["ForGroup"]
J.ForceAddPlayer = JassCommon["ForceAddPlayer"]
J.ForceCampaignSelectScreen = JassCommon["ForceCampaignSelectScreen"]
J.ForceCinematicSubtitles = JassCommon["ForceCinematicSubtitles"]
J.ForceClear = JassCommon["ForceClear"]
J.ForceEnumAllies = JassCommon["ForceEnumAllies"]
J.ForceEnumEnemies = JassCommon["ForceEnumEnemies"]
J.ForceEnumPlayers = JassCommon["ForceEnumPlayers"]
J.ForceEnumPlayersCounted = JassCommon["ForceEnumPlayersCounted"]
J.ForcePlayerStartLocation = JassCommon["ForcePlayerStartLocation"]
J.ForceQuestDialogUpdate = JassCommon["ForceQuestDialogUpdate"]
J.ForceRemovePlayer = JassCommon["ForceRemovePlayer"]
J.ForceUICancel = JassCommon["ForceUICancel"]
J.ForceUIKey = JassCommon["ForceUIKey"]
J.GetAIDifficulty = JassCommon["GetAIDifficulty"]
J.GetAbilityEffect = JassCommon["GetAbilityEffect"]
J.GetAbilityEffectById = JassCommon["GetAbilityEffectById"]
J.GetAbilitySound = JassCommon["GetAbilitySound"]
J.GetAbilitySoundById = JassCommon["GetAbilitySoundById"]
J.GetAllyColorFilterState = JassCommon["GetAllyColorFilterState"]
J.GetAttacker = JassCommon["GetAttacker"]
J.GetBuyingUnit = JassCommon["GetBuyingUnit"]
J.GetCameraBoundMaxX = JassCommon["GetCameraBoundMaxX"]
J.GetCameraBoundMaxY = JassCommon["GetCameraBoundMaxY"]
J.GetCameraBoundMinX = JassCommon["GetCameraBoundMinX"]
J.GetCameraBoundMinY = JassCommon["GetCameraBoundMinY"]
J.GetCameraEyePositionLoc = JassCommon["GetCameraEyePositionLoc"]
J.GetCameraEyePositionX = JassCommon["GetCameraEyePositionX"]
J.GetCameraEyePositionY = JassCommon["GetCameraEyePositionY"]
J.GetCameraEyePositionZ = JassCommon["GetCameraEyePositionZ"]
J.GetCameraField = JassCommon["GetCameraField"]
J.GetCameraMargin = JassCommon["GetCameraMargin"]
J.GetCameraTargetPositionLoc = JassCommon["GetCameraTargetPositionLoc"]
J.GetCameraTargetPositionX = JassCommon["GetCameraTargetPositionX"]
J.GetCameraTargetPositionY = JassCommon["GetCameraTargetPositionY"]
J.GetCameraTargetPositionZ = JassCommon["GetCameraTargetPositionZ"]
J.GetCancelledStructure = JassCommon["GetCancelledStructure"]
J.GetChangingUnit = JassCommon["GetChangingUnit"]
J.GetChangingUnitPrevOwner = JassCommon["GetChangingUnitPrevOwner"]
J.GetClickedButton = JassCommon["GetClickedButton"]
J.GetClickedDialog = JassCommon["GetClickedDialog"]
J.GetConstructedStructure = JassCommon["GetConstructedStructure"]
J.GetConstructingStructure = JassCommon["GetConstructingStructure"]
J.GetCreatureDensity = JassCommon["GetCreatureDensity"]
J.GetCreepCampFilterState = JassCommon["GetCreepCampFilterState"]
J.GetCustomCampaignButtonVisible = JassCommon["GetCustomCampaignButtonVisible"]
J.GetDecayingUnit = JassCommon["GetDecayingUnit"]
J.GetDefaultDifficulty = JassCommon["GetDefaultDifficulty"]
J.GetDestructableLife = JassCommon["GetDestructableLife"]
J.GetDestructableMaxLife = JassCommon["GetDestructableMaxLife"]
J.GetDestructableName = JassCommon["GetDestructableName"]
J.GetDestructableOccluderHeight = JassCommon["GetDestructableOccluderHeight"]
J.GetDestructableTypeId = JassCommon["GetDestructableTypeId"]
J.GetDestructableX = JassCommon["GetDestructableX"]
J.GetDestructableY = JassCommon["GetDestructableY"]
J.GetDetectedUnit = JassCommon["GetDetectedUnit"]
J.GetDyingUnit = JassCommon["GetDyingUnit"]
J.GetEnteringUnit = JassCommon["GetEnteringUnit"]
J.GetEnumDestructable = JassCommon["GetEnumDestructable"]
J.GetEnumItem = JassCommon["GetEnumItem"]
J.GetEnumPlayer = JassCommon["GetEnumPlayer"]
J.GetEnumUnit = JassCommon["GetEnumUnit"]
J.GetEventDamage = JassCommon["GetEventDamage"]
J.GetEventDamageSource = JassCommon["GetEventDamageSource"]
J.GetEventDetectingPlayer = JassCommon["GetEventDetectingPlayer"]
J.GetEventGameState = JassCommon["GetEventGameState"]
J.GetEventPlayerChatString = JassCommon["GetEventPlayerChatString"]
J.GetEventPlayerChatStringMatched = JassCommon["GetEventPlayerChatStringMatched"]
J.GetEventPlayerState = JassCommon["GetEventPlayerState"]
J.GetEventTargetUnit = JassCommon["GetEventTargetUnit"]
J.GetEventUnitState = JassCommon["GetEventUnitState"]
J.GetExpiredTimer = JassCommon["GetExpiredTimer"]
J.GetFilterDestructable = JassCommon["GetFilterDestructable"]
J.GetFilterItem = JassCommon["GetFilterItem"]
J.GetFilterPlayer = JassCommon["GetFilterPlayer"]
J.GetFilterUnit = JassCommon["GetFilterUnit"]
J.GetFloatGameState = JassCommon["GetFloatGameState"]
J.GetFoodMade = JassCommon["GetFoodMade"]
J.GetFoodUsed = JassCommon["GetFoodUsed"]
J.GetGameDifficulty = JassCommon["GetGameDifficulty"]
J.GetGamePlacement = JassCommon["GetGamePlacement"]
J.GetGameSpeed = JassCommon["GetGameSpeed"]
J.GetGameTypeSelected = JassCommon["GetGameTypeSelected"]
J.GetHandleId = JassCommon["GetHandleId"]
J.GetHeroAgi = JassCommon["GetHeroAgi"]
J.GetHeroInt = JassCommon["GetHeroInt"]
J.GetHeroLevel = JassCommon["GetHeroLevel"]
J.GetHeroProperName = JassCommon["GetHeroProperName"]
J.GetHeroSkillPoints = JassCommon["GetHeroSkillPoints"]
J.GetHeroStr = JassCommon["GetHeroStr"]
J.GetHeroXP = JassCommon["GetHeroXP"]
J.GetIntegerGameState = JassCommon["GetIntegerGameState"]
J.GetIssuedOrderId = JassCommon["GetIssuedOrderId"]
J.GetItemCharges = JassCommon["GetItemCharges"]
J.GetItemLevel = JassCommon["GetItemLevel"]
J.GetItemName = JassCommon["GetItemName"]
J.GetItemPlayer = JassCommon["GetItemPlayer"]
J.GetItemType = JassCommon["GetItemType"]
J.GetItemTypeId = JassCommon["GetItemTypeId"]
J.GetItemUserData = JassCommon["GetItemUserData"]
J.GetItemX = JassCommon["GetItemX"]
J.GetItemY = JassCommon["GetItemY"]
J.GetKillingUnit = JassCommon["GetKillingUnit"]
J.GetLearnedSkill = JassCommon["GetLearnedSkill"]
J.GetLearnedSkillLevel = JassCommon["GetLearnedSkillLevel"]
J.GetLearningUnit = JassCommon["GetLearningUnit"]
J.GetLeavingUnit = JassCommon["GetLeavingUnit"]
J.GetLevelingUnit = JassCommon["GetLevelingUnit"]
J.GetLightningColorA = JassCommon["GetLightningColorA"]
J.GetLightningColorB = JassCommon["GetLightningColorB"]
J.GetLightningColorG = JassCommon["GetLightningColorG"]
J.GetLightningColorR = JassCommon["GetLightningColorR"]
J.GetLoadedUnit = JassCommon["GetLoadedUnit"]
J.GetLocalizedHotkey = JassCommon["GetLocalizedHotkey"]
J.GetLocalizedString = JassCommon["GetLocalizedString"]
J.GetLocationX = JassCommon["GetLocationX"]
J.GetLocationY = JassCommon["GetLocationY"]
J.GetLocationZ = JassCommon["GetLocationZ"]
J.GetManipulatedItem = JassCommon["GetManipulatedItem"]
J.GetManipulatingUnit = JassCommon["GetManipulatingUnit"]
J.GetObjectName = JassCommon["GetObjectName"]
J.GetOrderPointLoc = JassCommon["GetOrderPointLoc"]
J.GetOrderPointX = JassCommon["GetOrderPointX"]
J.GetOrderPointY = JassCommon["GetOrderPointY"]
J.GetOrderTarget = JassCommon["GetOrderTarget"]
J.GetOrderTargetDestructable = JassCommon["GetOrderTargetDestructable"]
J.GetOrderTargetItem = JassCommon["GetOrderTargetItem"]
J.GetOrderTargetUnit = JassCommon["GetOrderTargetUnit"]
J.GetOrderedUnit = JassCommon["GetOrderedUnit"]
J.GetOwningPlayer = JassCommon["GetOwningPlayer"]
J.GetPlayerAlliance = JassCommon["GetPlayerAlliance"]
J.GetPlayerColor = JassCommon["GetPlayerColor"]
J.GetPlayerController = JassCommon["GetPlayerController"]
J.GetPlayerHandicap = JassCommon["GetPlayerHandicap"]
J.GetPlayerHandicapXP = JassCommon["GetPlayerHandicapXP"]
J.GetPlayerId = JassCommon["GetPlayerId"]
J.GetPlayerName = JassCommon["GetPlayerName"]
J.GetPlayerRace = JassCommon["GetPlayerRace"]
J.GetPlayerScore = JassCommon["GetPlayerScore"]
J.GetPlayerSelectable = JassCommon["GetPlayerSelectable"]
J.GetPlayerSlotState = JassCommon["GetPlayerSlotState"]
J.GetPlayerStartLocation = JassCommon["GetPlayerStartLocation"]
J.GetPlayerState = JassCommon["GetPlayerState"]
J.GetPlayerStructureCount = JassCommon["GetPlayerStructureCount"]
J.GetPlayerTaxRate = JassCommon["GetPlayerTaxRate"]
J.GetPlayerTeam = JassCommon["GetPlayerTeam"]
J.GetPlayerTechCount = JassCommon["GetPlayerTechCount"]
J.GetPlayerTechMaxAllowed = JassCommon["GetPlayerTechMaxAllowed"]
J.GetPlayerTechResearched = JassCommon["GetPlayerTechResearched"]
J.GetPlayerTypedUnitCount = JassCommon["GetPlayerTypedUnitCount"]
J.GetPlayerUnitCount = JassCommon["GetPlayerUnitCount"]
J.GetPlayers = JassCommon["GetPlayers"]
J.GetRandomInt = JassCommon["GetRandomInt"]
J.GetRandomReal = JassCommon["GetRandomReal"]
J.GetRectCenterX = JassCommon["GetRectCenterX"]
J.GetRectCenterY = JassCommon["GetRectCenterY"]
J.GetRectMaxX = JassCommon["GetRectMaxX"]
J.GetRectMaxY = JassCommon["GetRectMaxY"]
J.GetRectMinX = JassCommon["GetRectMinX"]
J.GetRectMinY = JassCommon["GetRectMinY"]
J.GetRescuer = JassCommon["GetRescuer"]
J.GetResearched = JassCommon["GetResearched"]
J.GetResearchingUnit = JassCommon["GetResearchingUnit"]
J.GetResourceAmount = JassCommon["GetResourceAmount"]
J.GetResourceDensity = JassCommon["GetResourceDensity"]
J.GetRevivableUnit = JassCommon["GetRevivableUnit"]
J.GetRevivingUnit = JassCommon["GetRevivingUnit"]
J.GetSaveBasicFilename = JassCommon["GetSaveBasicFilename"]
J.GetSellingUnit = JassCommon["GetSellingUnit"]
J.GetSoldItem = JassCommon["GetSoldItem"]
J.GetSoldUnit = JassCommon["GetSoldUnit"]
J.GetSoundDuration = JassCommon["GetSoundDuration"]
J.GetSoundFileDuration = JassCommon["GetSoundFileDuration"]
J.GetSoundIsLoading = JassCommon["GetSoundIsLoading"]
J.GetSoundIsPlaying = JassCommon["GetSoundIsPlaying"]
J.GetSpellAbility = JassCommon["GetSpellAbility"]
J.GetSpellAbilityId = JassCommon["GetSpellAbilityId"]
J.GetSpellAbilityUnit = JassCommon["GetSpellAbilityUnit"]
J.GetSpellTargetDestructable = JassCommon["GetSpellTargetDestructable"]
J.GetSpellTargetItem = JassCommon["GetSpellTargetItem"]
J.GetSpellTargetLoc = JassCommon["GetSpellTargetLoc"]
J.GetSpellTargetUnit = JassCommon["GetSpellTargetUnit"]
J.GetSpellTargetX = JassCommon["GetSpellTargetX"]
J.GetSpellTargetY = JassCommon["GetSpellTargetY"]
J.GetStartLocPrio = JassCommon["GetStartLocPrio"]
J.GetStartLocPrioSlot = JassCommon["GetStartLocPrioSlot"]
J.GetStartLocationLoc = JassCommon["GetStartLocationLoc"]
J.GetStartLocationX = JassCommon["GetStartLocationX"]
J.GetStartLocationY = JassCommon["GetStartLocationY"]
J.GetStoredBoolean = JassCommon["GetStoredBoolean"]
J.GetStoredInteger = JassCommon["GetStoredInteger"]
J.GetStoredReal = JassCommon["GetStoredReal"]
J.GetStoredString = JassCommon["GetStoredString"]
J.GetSummonedUnit = JassCommon["GetSummonedUnit"]
J.GetSummoningUnit = JassCommon["GetSummoningUnit"]
J.GetTeams = JassCommon["GetTeams"]
J.GetTerrainCliffLevel = JassCommon["GetTerrainCliffLevel"]
J.GetTerrainType = JassCommon["GetTerrainType"]
J.GetTerrainVariance = JassCommon["GetTerrainVariance"]
J.GetTimeOfDayScale = JassCommon["GetTimeOfDayScale"]
J.GetTournamentFinishNowPlayer = JassCommon["GetTournamentFinishNowPlayer"]
J.GetTournamentFinishNowRule = JassCommon["GetTournamentFinishNowRule"]
J.GetTournamentFinishSoonTimeRemaining = JassCommon["GetTournamentFinishSoonTimeRemaining"]
J.GetTournamentScore = JassCommon["GetTournamentScore"]
J.GetTrainedUnit = JassCommon["GetTrainedUnit"]
J.GetTrainedUnitType = JassCommon["GetTrainedUnitType"]
J.GetTransportUnit = JassCommon["GetTransportUnit"]
J.GetTriggerDestructable = JassCommon["GetTriggerDestructable"]
J.GetTriggerEvalCount = JassCommon["GetTriggerEvalCount"]
J.GetTriggerEventId = JassCommon["GetTriggerEventId"]
J.GetTriggerExecCount = JassCommon["GetTriggerExecCount"]
J.GetTriggerPlayer = JassCommon["GetTriggerPlayer"]
J.GetTriggerUnit = JassCommon["GetTriggerUnit"]
J.GetTriggerWidget = JassCommon["GetTriggerWidget"]
J.GetTriggeringRegion = JassCommon["GetTriggeringRegion"]
J.GetTriggeringTrackable = JassCommon["GetTriggeringTrackable"]
J.GetTriggeringTrigger = JassCommon["GetTriggeringTrigger"]
J.GetUnitAbilityLevel = JassCommon["GetUnitAbilityLevel"]
J.GetUnitAcquireRange = JassCommon["GetUnitAcquireRange"]
J.GetUnitCurrentOrder = JassCommon["GetUnitCurrentOrder"]
J.GetUnitDefaultAcquireRange = JassCommon["GetUnitDefaultAcquireRange"]
J.GetUnitDefaultFlyHeight = JassCommon["GetUnitDefaultFlyHeight"]
J.GetUnitDefaultMoveSpeed = JassCommon["GetUnitDefaultMoveSpeed"]
J.GetUnitDefaultPropWindow = JassCommon["GetUnitDefaultPropWindow"]
J.GetUnitDefaultTurnSpeed = JassCommon["GetUnitDefaultTurnSpeed"]
J.GetUnitFacing = JassCommon["GetUnitFacing"]
J.GetUnitFlyHeight = JassCommon["GetUnitFlyHeight"]
J.GetUnitFoodMade = JassCommon["GetUnitFoodMade"]
J.GetUnitFoodUsed = JassCommon["GetUnitFoodUsed"]
J.GetUnitLevel = JassCommon["GetUnitLevel"]
J.GetUnitLoc = JassCommon["GetUnitLoc"]
J.GetUnitMoveSpeed = JassCommon["GetUnitMoveSpeed"]
J.GetUnitName = JassCommon["GetUnitName"]
J.GetUnitPointValue = JassCommon["GetUnitPointValue"]
J.GetUnitPointValueByType = JassCommon["GetUnitPointValueByType"]
J.GetUnitPropWindow = JassCommon["GetUnitPropWindow"]
J.GetUnitRace = JassCommon["GetUnitRace"]
J.GetUnitRallyDestructable = JassCommon["GetUnitRallyDestructable"]
J.GetUnitRallyPoint = JassCommon["GetUnitRallyPoint"]
J.GetUnitRallyUnit = JassCommon["GetUnitRallyUnit"]
J.GetUnitState = JassCommon["GetUnitState"]
J.GetUnitTurnSpeed = JassCommon["GetUnitTurnSpeed"]
J.GetUnitTypeId = JassCommon["GetUnitTypeId"]
J.GetUnitUserData = JassCommon["GetUnitUserData"]
J.GetUnitX = JassCommon["GetUnitX"]
J.GetUnitY = JassCommon["GetUnitY"]
J.GetWidgetLife = JassCommon["GetWidgetLife"]
J.GetWidgetX = JassCommon["GetWidgetX"]
J.GetWidgetY = JassCommon["GetWidgetY"]
J.GetWinningPlayer = JassCommon["GetWinningPlayer"]
J.GetWorldBounds = JassCommon["GetWorldBounds"]
J.GroupAddUnit = JassCommon["GroupAddUnit"]
J.GroupClear = JassCommon["GroupClear"]
J.GroupEnumUnitsInRange = JassCommon["GroupEnumUnitsInRange"]
J.GroupEnumUnitsInRangeCounted = JassCommon["GroupEnumUnitsInRangeCounted"]
J.GroupEnumUnitsInRangeOfLoc = JassCommon["GroupEnumUnitsInRangeOfLoc"]
J.GroupEnumUnitsInRangeOfLocCounted = JassCommon["GroupEnumUnitsInRangeOfLocCounted"]
J.GroupEnumUnitsInRect = JassCommon["GroupEnumUnitsInRect"]
J.GroupEnumUnitsInRectCounted = JassCommon["GroupEnumUnitsInRectCounted"]
J.GroupEnumUnitsOfPlayer = JassCommon["GroupEnumUnitsOfPlayer"]
J.GroupEnumUnitsOfType = JassCommon["GroupEnumUnitsOfType"]
J.GroupEnumUnitsOfTypeCounted = JassCommon["GroupEnumUnitsOfTypeCounted"]
J.GroupEnumUnitsSelected = JassCommon["GroupEnumUnitsSelected"]
J.GroupImmediateOrder = JassCommon["GroupImmediateOrder"]
J.GroupImmediateOrderById = JassCommon["GroupImmediateOrderById"]
J.GroupPointOrder = JassCommon["GroupPointOrder"]
J.GroupPointOrderById = JassCommon["GroupPointOrderById"]
J.GroupPointOrderByIdLoc = JassCommon["GroupPointOrderByIdLoc"]
J.GroupPointOrderLoc = JassCommon["GroupPointOrderLoc"]
J.GroupRemoveUnit = JassCommon["GroupRemoveUnit"]
J.GroupTargetOrder = JassCommon["GroupTargetOrder"]
J.GroupTargetOrderById = JassCommon["GroupTargetOrderById"]
J.HaveSavedBoolean = JassCommon["HaveSavedBoolean"]
J.HaveSavedHandle = JassCommon["HaveSavedHandle"]
J.HaveSavedInteger = JassCommon["HaveSavedInteger"]
J.HaveSavedReal = JassCommon["HaveSavedReal"]
J.HaveSavedString = JassCommon["HaveSavedString"]
J.HaveStoredBoolean = JassCommon["HaveStoredBoolean"]
J.HaveStoredInteger = JassCommon["HaveStoredInteger"]
J.HaveStoredReal = JassCommon["HaveStoredReal"]
J.HaveStoredString = JassCommon["HaveStoredString"]
J.HaveStoredUnit = JassCommon["HaveStoredUnit"]
J.I2R = JassCommon["I2R"]
J.I2S = JassCommon["I2S"]
J.IncUnitAbilityLevel = JassCommon["IncUnitAbilityLevel"]
J.InitGameCache = JassCommon["InitGameCache"]
J.InitHashtable = JassCommon["InitHashtable"]
J.IsCineFilterDisplayed = JassCommon["IsCineFilterDisplayed"]
J.IsDestructableInvulnerable = JassCommon["IsDestructableInvulnerable"]
J.IsFogEnabled = JassCommon["IsFogEnabled"]
J.IsFogMaskEnabled = JassCommon["IsFogMaskEnabled"]
J.IsFoggedToPlayer = JassCommon["IsFoggedToPlayer"]
J.IsGameTypeSupported = JassCommon["IsGameTypeSupported"]
J.IsHeroUnitId = JassCommon["IsHeroUnitId"]
J.IsItemIdPawnable = JassCommon["IsItemIdPawnable"]
J.IsItemIdPowerup = JassCommon["IsItemIdPowerup"]
J.IsItemIdSellable = JassCommon["IsItemIdSellable"]
J.IsItemInvulnerable = JassCommon["IsItemInvulnerable"]
J.IsItemOwned = JassCommon["IsItemOwned"]
J.IsItemPawnable = JassCommon["IsItemPawnable"]
J.IsItemPowerup = JassCommon["IsItemPowerup"]
J.IsItemSellable = JassCommon["IsItemSellable"]
J.IsItemVisible = JassCommon["IsItemVisible"]
J.IsLeaderboardDisplayed = JassCommon["IsLeaderboardDisplayed"]
J.IsLocationFoggedToPlayer = JassCommon["IsLocationFoggedToPlayer"]
J.IsLocationInRegion = JassCommon["IsLocationInRegion"]
J.IsLocationMaskedToPlayer = JassCommon["IsLocationMaskedToPlayer"]
J.IsLocationVisibleToPlayer = JassCommon["IsLocationVisibleToPlayer"]
J.IsMapFlagSet = JassCommon["IsMapFlagSet"]
J.IsMaskedToPlayer = JassCommon["IsMaskedToPlayer"]
J.IsMultiboardDisplayed = JassCommon["IsMultiboardDisplayed"]
J.IsMultiboardMinimized = JassCommon["IsMultiboardMinimized"]
J.IsNoDefeatCheat = JassCommon["IsNoDefeatCheat"]
J.IsNoVictoryCheat = JassCommon["IsNoVictoryCheat"]
J.IsPlayerAlly = JassCommon["IsPlayerAlly"]
J.IsPlayerEnemy = JassCommon["IsPlayerEnemy"]
J.IsPlayerInForce = JassCommon["IsPlayerInForce"]
J.IsPlayerObserver = JassCommon["IsPlayerObserver"]
J.IsPlayerRacePrefSet = JassCommon["IsPlayerRacePrefSet"]
J.IsPointBlighted = JassCommon["IsPointBlighted"]
J.IsPointInRegion = JassCommon["IsPointInRegion"]
J.IsQuestCompleted = JassCommon["IsQuestCompleted"]
J.IsQuestDiscovered = JassCommon["IsQuestDiscovered"]
J.IsQuestEnabled = JassCommon["IsQuestEnabled"]
J.IsQuestFailed = JassCommon["IsQuestFailed"]
J.IsQuestItemCompleted = JassCommon["IsQuestItemCompleted"]
J.IsQuestRequired = JassCommon["IsQuestRequired"]
J.IsSuspendedXP = JassCommon["IsSuspendedXP"]
J.IsTerrainPathable = JassCommon["IsTerrainPathable"]
J.IsTimerDialogDisplayed = JassCommon["IsTimerDialogDisplayed"]
J.IsTriggerEnabled = JassCommon["IsTriggerEnabled"]
J.IsTriggerWaitOnSleeps = JassCommon["IsTriggerWaitOnSleeps"]
J.IsUnit = JassCommon["IsUnit"]
J.IsUnitAlly = JassCommon["IsUnitAlly"]
J.IsUnitDetected = JassCommon["IsUnitDetected"]
J.IsUnitEnemy = JassCommon["IsUnitEnemy"]
J.IsUnitFogged = JassCommon["IsUnitFogged"]
J.IsUnitHidden = JassCommon["IsUnitHidden"]
J.IsUnitIdType = JassCommon["IsUnitIdType"]
J.IsUnitIllusion = JassCommon["IsUnitIllusion"]
J.IsUnitInForce = JassCommon["IsUnitInForce"]
J.IsUnitInGroup = JassCommon["IsUnitInGroup"]
J.IsUnitInRange = JassCommon["IsUnitInRange"]
J.IsUnitInRangeLoc = JassCommon["IsUnitInRangeLoc"]
J.IsUnitInRangeXY = JassCommon["IsUnitInRangeXY"]
J.IsUnitInRegion = JassCommon["IsUnitInRegion"]
J.IsUnitInTransport = JassCommon["IsUnitInTransport"]
J.IsUnitInvisible = JassCommon["IsUnitInvisible"]
J.IsUnitLoaded = JassCommon["IsUnitLoaded"]
J.IsUnitMasked = JassCommon["IsUnitMasked"]
J.IsUnitOwnedByPlayer = JassCommon["IsUnitOwnedByPlayer"]
J.IsUnitPaused = JassCommon["IsUnitPaused"]
J.IsUnitRace = JassCommon["IsUnitRace"]
J.IsUnitSelected = JassCommon["IsUnitSelected"]
J.IsUnitType = JassCommon["IsUnitType"]
J.IsUnitVisible = JassCommon["IsUnitVisible"]
J.IsVisibleToPlayer = JassCommon["IsVisibleToPlayer"]
J.IssueBuildOrder = JassCommon["IssueBuildOrder"]
J.IssueBuildOrderById = JassCommon["IssueBuildOrderById"]
J.IssueImmediateOrder = JassCommon["IssueImmediateOrder"]
J.IssueImmediateOrderById = JassCommon["IssueImmediateOrderById"]
J.IssueInstantPointOrder = JassCommon["IssueInstantPointOrder"]
J.IssueInstantPointOrderById = JassCommon["IssueInstantPointOrderById"]
J.IssueInstantTargetOrder = JassCommon["IssueInstantTargetOrder"]
J.IssueInstantTargetOrderById = JassCommon["IssueInstantTargetOrderById"]
J.IssueNeutralImmediateOrder = JassCommon["IssueNeutralImmediateOrder"]
J.IssueNeutralImmediateOrderById = JassCommon["IssueNeutralImmediateOrderById"]
J.IssueNeutralPointOrder = JassCommon["IssueNeutralPointOrder"]
J.IssueNeutralPointOrderById = JassCommon["IssueNeutralPointOrderById"]
J.IssueNeutralTargetOrder = JassCommon["IssueNeutralTargetOrder"]
J.IssueNeutralTargetOrderById = JassCommon["IssueNeutralTargetOrderById"]
J.IssuePointOrder = JassCommon["IssuePointOrder"]
J.IssuePointOrderById = JassCommon["IssuePointOrderById"]
J.IssuePointOrderByIdLoc = JassCommon["IssuePointOrderByIdLoc"]
J.IssuePointOrderLoc = JassCommon["IssuePointOrderLoc"]
J.IssueTargetOrder = JassCommon["IssueTargetOrder"]
J.IssueTargetOrderById = JassCommon["IssueTargetOrderById"]
J.ItemPoolAddItemType = JassCommon["ItemPoolAddItemType"]
J.ItemPoolRemoveItemType = JassCommon["ItemPoolRemoveItemType"]
J.KillDestructable = JassCommon["KillDestructable"]
J.KillSoundWhenDone = JassCommon["KillSoundWhenDone"]
J.KillUnit = JassCommon["KillUnit"]
J.LeaderboardAddItem = JassCommon["LeaderboardAddItem"]
J.LeaderboardClear = JassCommon["LeaderboardClear"]
J.LeaderboardDisplay = JassCommon["LeaderboardDisplay"]
J.LeaderboardGetItemCount = JassCommon["LeaderboardGetItemCount"]
J.LeaderboardGetLabelText = JassCommon["LeaderboardGetLabelText"]
J.LeaderboardGetPlayerIndex = JassCommon["LeaderboardGetPlayerIndex"]
J.LeaderboardHasPlayerItem = JassCommon["LeaderboardHasPlayerItem"]
J.LeaderboardRemoveItem = JassCommon["LeaderboardRemoveItem"]
J.LeaderboardRemovePlayerItem = JassCommon["LeaderboardRemovePlayerItem"]
J.LeaderboardSetItemLabel = JassCommon["LeaderboardSetItemLabel"]
J.LeaderboardSetItemLabelColor = JassCommon["LeaderboardSetItemLabelColor"]
J.LeaderboardSetItemStyle = JassCommon["LeaderboardSetItemStyle"]
J.LeaderboardSetItemValue = JassCommon["LeaderboardSetItemValue"]
J.LeaderboardSetItemValueColor = JassCommon["LeaderboardSetItemValueColor"]
J.LeaderboardSetLabel = JassCommon["LeaderboardSetLabel"]
J.LeaderboardSetLabelColor = JassCommon["LeaderboardSetLabelColor"]
J.LeaderboardSetSizeByItemCount = JassCommon["LeaderboardSetSizeByItemCount"]
J.LeaderboardSetStyle = JassCommon["LeaderboardSetStyle"]
J.LeaderboardSetValueColor = JassCommon["LeaderboardSetValueColor"]
J.LeaderboardSortItemsByLabel = JassCommon["LeaderboardSortItemsByLabel"]
J.LeaderboardSortItemsByPlayer = JassCommon["LeaderboardSortItemsByPlayer"]
J.LeaderboardSortItemsByValue = JassCommon["LeaderboardSortItemsByValue"]
J.LoadAbilityHandle = JassCommon["LoadAbilityHandle"]
J.LoadBoolean = JassCommon["LoadBoolean"]
J.LoadBooleanExprHandle = JassCommon["LoadBooleanExprHandle"]
J.LoadButtonHandle = JassCommon["LoadButtonHandle"]
J.LoadDefeatConditionHandle = JassCommon["LoadDefeatConditionHandle"]
J.LoadDestructableHandle = JassCommon["LoadDestructableHandle"]
J.LoadDialogHandle = JassCommon["LoadDialogHandle"]
J.LoadEffectHandle = JassCommon["LoadEffectHandle"]
J.LoadFogModifierHandle = JassCommon["LoadFogModifierHandle"]
J.LoadFogStateHandle = JassCommon["LoadFogStateHandle"]
J.LoadForceHandle = JassCommon["LoadForceHandle"]
J.LoadGame = JassCommon["LoadGame"]
J.LoadGroupHandle = JassCommon["LoadGroupHandle"]
J.LoadHashtableHandle = JassCommon["LoadHashtableHandle"]
J.LoadImageHandle = JassCommon["LoadImageHandle"]
J.LoadInteger = JassCommon["LoadInteger"]
J.LoadItemHandle = JassCommon["LoadItemHandle"]
J.LoadItemPoolHandle = JassCommon["LoadItemPoolHandle"]
J.LoadLeaderboardHandle = JassCommon["LoadLeaderboardHandle"]
J.LoadLightningHandle = JassCommon["LoadLightningHandle"]
J.LoadLocationHandle = JassCommon["LoadLocationHandle"]
J.LoadMultiboardHandle = JassCommon["LoadMultiboardHandle"]
J.LoadMultiboardItemHandle = JassCommon["LoadMultiboardItemHandle"]
J.LoadPlayerHandle = JassCommon["LoadPlayerHandle"]
J.LoadQuestHandle = JassCommon["LoadQuestHandle"]
J.LoadQuestItemHandle = JassCommon["LoadQuestItemHandle"]
J.LoadReal = JassCommon["LoadReal"]
J.LoadRectHandle = JassCommon["LoadRectHandle"]
J.LoadRegionHandle = JassCommon["LoadRegionHandle"]
J.LoadSoundHandle = JassCommon["LoadSoundHandle"]
J.LoadStr = JassCommon["LoadStr"]
J.LoadTextTagHandle = JassCommon["LoadTextTagHandle"]
J.LoadTimerDialogHandle = JassCommon["LoadTimerDialogHandle"]
J.LoadTimerHandle = JassCommon["LoadTimerHandle"]
J.LoadTrackableHandle = JassCommon["LoadTrackableHandle"]
J.LoadTriggerActionHandle = JassCommon["LoadTriggerActionHandle"]
J.LoadTriggerConditionHandle = JassCommon["LoadTriggerConditionHandle"]
J.LoadTriggerEventHandle = JassCommon["LoadTriggerEventHandle"]
J.LoadTriggerHandle = JassCommon["LoadTriggerHandle"]
J.LoadUbersplatHandle = JassCommon["LoadUbersplatHandle"]
J.LoadUnitHandle = JassCommon["LoadUnitHandle"]
J.LoadUnitPoolHandle = JassCommon["LoadUnitPoolHandle"]
J.LoadWidgetHandle = JassCommon["LoadWidgetHandle"]
J.Location = JassCommon["Location"]
J.MoveLightning = JassCommon["MoveLightning"]
J.MoveLightningEx = JassCommon["MoveLightningEx"]
J.MoveLocation = JassCommon["MoveLocation"]
J.MoveRectTo = JassCommon["MoveRectTo"]
J.MoveRectToLoc = JassCommon["MoveRectToLoc"]
J.MultiboardClear = JassCommon["MultiboardClear"]
J.MultiboardDisplay = JassCommon["MultiboardDisplay"]
J.MultiboardGetColumnCount = JassCommon["MultiboardGetColumnCount"]
J.MultiboardGetItem = JassCommon["MultiboardGetItem"]
J.MultiboardGetRowCount = JassCommon["MultiboardGetRowCount"]
J.MultiboardGetTitleText = JassCommon["MultiboardGetTitleText"]
J.MultiboardMinimize = JassCommon["MultiboardMinimize"]
J.MultiboardReleaseItem = JassCommon["MultiboardReleaseItem"]
J.MultiboardSetColumnCount = JassCommon["MultiboardSetColumnCount"]
J.MultiboardSetItemIcon = JassCommon["MultiboardSetItemIcon"]
J.MultiboardSetItemStyle = JassCommon["MultiboardSetItemStyle"]
J.MultiboardSetItemValue = JassCommon["MultiboardSetItemValue"]
J.MultiboardSetItemValueColor = JassCommon["MultiboardSetItemValueColor"]
J.MultiboardSetItemWidth = JassCommon["MultiboardSetItemWidth"]
J.MultiboardSetItemsIcon = JassCommon["MultiboardSetItemsIcon"]
J.MultiboardSetItemsStyle = JassCommon["MultiboardSetItemsStyle"]
J.MultiboardSetItemsValue = JassCommon["MultiboardSetItemsValue"]
J.MultiboardSetItemsValueColor = JassCommon["MultiboardSetItemsValueColor"]
J.MultiboardSetItemsWidth = JassCommon["MultiboardSetItemsWidth"]
J.MultiboardSetRowCount = JassCommon["MultiboardSetRowCount"]
J.MultiboardSetTitleText = JassCommon["MultiboardSetTitleText"]
J.MultiboardSetTitleTextColor = JassCommon["MultiboardSetTitleTextColor"]
J.MultiboardSuppressDisplay = JassCommon["MultiboardSuppressDisplay"]
J.NewSoundEnvironment = JassCommon["NewSoundEnvironment"]
J.Not = JassCommon["Not"]
J.Or = JassCommon["Or"]
J.OrderId = JassCommon["OrderId"]
J.OrderId2String = JassCommon["OrderId2String"]
J.PanCameraTo = JassCommon["PanCameraTo"]
J.PanCameraToTimed = JassCommon["PanCameraToTimed"]
J.PanCameraToTimedWithZ = JassCommon["PanCameraToTimedWithZ"]
J.PanCameraToWithZ = JassCommon["PanCameraToWithZ"]
J.PauseCompAI = JassCommon["PauseCompAI"]
J.PauseGame = JassCommon["PauseGame"]
J.PauseTimer = JassCommon["PauseTimer"]
J.PauseUnit = JassCommon["PauseUnit"]
J.PingMinimap = JassCommon["PingMinimap"]
J.PingMinimapEx = JassCommon["PingMinimapEx"]
J.PlaceRandomItem = JassCommon["PlaceRandomItem"]
J.PlaceRandomUnit = JassCommon["PlaceRandomUnit"]
J.PlayCinematic = JassCommon["PlayCinematic"]
J.PlayModelCinematic = JassCommon["PlayModelCinematic"]
J.PlayMusic = JassCommon["PlayMusic"]
J.PlayMusicEx = JassCommon["PlayMusicEx"]
J.PlayThematicMusic = JassCommon["PlayThematicMusic"]
J.PlayThematicMusicEx = JassCommon["PlayThematicMusicEx"]
J.Player = JassCommon["Player"]
J.PlayerGetLeaderboard = JassCommon["PlayerGetLeaderboard"]
J.PlayerSetLeaderboard = JassCommon["PlayerSetLeaderboard"]
J.Pow = JassCommon["Pow"]
J.Preload = JassCommon["Preload"]
J.PreloadEnd = JassCommon["PreloadEnd"]
J.PreloadEndEx = JassCommon["PreloadEndEx"]
J.PreloadGenClear = JassCommon["PreloadGenClear"]
J.PreloadGenEnd = JassCommon["PreloadGenEnd"]
J.PreloadGenStart = JassCommon["PreloadGenStart"]
J.PreloadRefresh = JassCommon["PreloadRefresh"]
J.PreloadStart = JassCommon["PreloadStart"]
J.Preloader = JassCommon["Preloader"]
J.QuestCreateItem = JassCommon["QuestCreateItem"]
J.QuestItemSetCompleted = JassCommon["QuestItemSetCompleted"]
J.QuestItemSetDescription = JassCommon["QuestItemSetDescription"]
J.QuestSetCompleted = JassCommon["QuestSetCompleted"]
J.QuestSetDescription = JassCommon["QuestSetDescription"]
J.QuestSetDiscovered = JassCommon["QuestSetDiscovered"]
J.QuestSetEnabled = JassCommon["QuestSetEnabled"]
J.QuestSetFailed = JassCommon["QuestSetFailed"]
J.QuestSetIconPath = JassCommon["QuestSetIconPath"]
J.QuestSetRequired = JassCommon["QuestSetRequired"]
J.QuestSetTitle = JassCommon["QuestSetTitle"]
J.QueueDestructableAnimation = JassCommon["QueueDestructableAnimation"]
J.QueueUnitAnimation = JassCommon["QueueUnitAnimation"]
J.R2I = JassCommon["R2I"]
J.R2S = JassCommon["R2S"]
J.R2SW = JassCommon["R2SW"]
J.Rad2Deg = JassCommon["Rad2Deg"]
J.Rect = JassCommon["Rect"]
J.RectFromLoc = JassCommon["RectFromLoc"]
J.RecycleGuardPosition = JassCommon["RecycleGuardPosition"]
J.RegionAddCell = JassCommon["RegionAddCell"]
J.RegionAddCellAtLoc = JassCommon["RegionAddCellAtLoc"]
J.RegionAddRect = JassCommon["RegionAddRect"]
J.RegionClearCell = JassCommon["RegionClearCell"]
J.RegionClearCellAtLoc = JassCommon["RegionClearCellAtLoc"]
J.RegionClearRect = JassCommon["RegionClearRect"]
J.RegisterStackedSound = JassCommon["RegisterStackedSound"]
J.ReloadGame = JassCommon["ReloadGame"]
J.ReloadGameCachesFromDisk = JassCommon["ReloadGameCachesFromDisk"]
J.RemoveAllGuardPositions = JassCommon["RemoveAllGuardPositions"]
J.RemoveDestructable = JassCommon["RemoveDestructable"]
J.RemoveGuardPosition = JassCommon["RemoveGuardPosition"]
J.RemoveItem = JassCommon["RemoveItem"]
J.RemoveItemFromAllStock = JassCommon["RemoveItemFromAllStock"]
J.RemoveItemFromStock = JassCommon["RemoveItemFromStock"]
J.RemoveLocation = JassCommon["RemoveLocation"]
J.RemovePlayer = JassCommon["RemovePlayer"]
J.RemoveRect = JassCommon["RemoveRect"]
J.RemoveRegion = JassCommon["RemoveRegion"]
J.RemoveSaveDirectory = JassCommon["RemoveSaveDirectory"]
J.RemoveSavedBoolean = JassCommon["RemoveSavedBoolean"]
J.RemoveSavedHandle = JassCommon["RemoveSavedHandle"]
J.RemoveSavedInteger = JassCommon["RemoveSavedInteger"]
J.RemoveSavedReal = JassCommon["RemoveSavedReal"]
J.RemoveSavedString = JassCommon["RemoveSavedString"]
J.RemoveUnit = JassCommon["RemoveUnit"]
J.RemoveUnitFromAllStock = JassCommon["RemoveUnitFromAllStock"]
J.RemoveUnitFromStock = JassCommon["RemoveUnitFromStock"]
J.RemoveWeatherEffect = JassCommon["RemoveWeatherEffect"]
J.RenameSaveDirectory = JassCommon["RenameSaveDirectory"]
J.ResetTerrainFog = JassCommon["ResetTerrainFog"]
J.ResetToGameCamera = JassCommon["ResetToGameCamera"]
J.ResetTrigger = JassCommon["ResetTrigger"]
J.ResetUbersplat = JassCommon["ResetUbersplat"]
J.ResetUnitLookAt = JassCommon["ResetUnitLookAt"]
J.RestartGame = JassCommon["RestartGame"]
J.RestoreUnit = JassCommon["RestoreUnit"]
J.ResumeMusic = JassCommon["ResumeMusic"]
J.ResumeTimer = JassCommon["ResumeTimer"]
J.ReviveHero = JassCommon["ReviveHero"]
J.ReviveHeroLoc = JassCommon["ReviveHeroLoc"]
J.S2I = JassCommon["S2I"]
J.S2R = JassCommon["S2R"]
J.SaveAbilityHandle = JassCommon["SaveAbilityHandle"]
J.SaveBoolean = JassCommon["SaveBoolean"]
J.SaveBooleanExprHandle = JassCommon["SaveBooleanExprHandle"]
J.SaveButtonHandle = JassCommon["SaveButtonHandle"]
J.SaveDefeatConditionHandle = JassCommon["SaveDefeatConditionHandle"]
J.SaveDestructableHandle = JassCommon["SaveDestructableHandle"]
J.SaveDialogHandle = JassCommon["SaveDialogHandle"]
J.SaveEffectHandle = JassCommon["SaveEffectHandle"]
J.SaveFogModifierHandle = JassCommon["SaveFogModifierHandle"]
J.SaveFogStateHandle = JassCommon["SaveFogStateHandle"]
J.SaveForceHandle = JassCommon["SaveForceHandle"]
J.SaveGame = JassCommon["SaveGame"]
J.SaveGameCache = JassCommon["SaveGameCache"]
J.SaveGameExists = JassCommon["SaveGameExists"]
J.SaveGroupHandle = JassCommon["SaveGroupHandle"]
J.SaveImageHandle = JassCommon["SaveImageHandle"]
J.SaveInteger = JassCommon["SaveInteger"]
J.SaveItemHandle = JassCommon["SaveItemHandle"]
J.SaveItemPoolHandle = JassCommon["SaveItemPoolHandle"]
J.SaveLeaderboardHandle = JassCommon["SaveLeaderboardHandle"]
J.SaveLightningHandle = JassCommon["SaveLightningHandle"]
J.SaveLocationHandle = JassCommon["SaveLocationHandle"]
J.SaveMultiboardHandle = JassCommon["SaveMultiboardHandle"]
J.SaveMultiboardItemHandle = JassCommon["SaveMultiboardItemHandle"]
J.SavePlayerHandle = JassCommon["SavePlayerHandle"]
J.SaveQuestHandle = JassCommon["SaveQuestHandle"]
J.SaveQuestItemHandle = JassCommon["SaveQuestItemHandle"]
J.SaveReal = JassCommon["SaveReal"]
J.SaveRectHandle = JassCommon["SaveRectHandle"]
J.SaveRegionHandle = JassCommon["SaveRegionHandle"]
J.SaveSoundHandle = JassCommon["SaveSoundHandle"]
J.SaveStr = JassCommon["SaveStr"]
J.SaveTextTagHandle = JassCommon["SaveTextTagHandle"]
J.SaveTimerDialogHandle = JassCommon["SaveTimerDialogHandle"]
J.SaveTimerHandle = JassCommon["SaveTimerHandle"]
J.SaveTrackableHandle = JassCommon["SaveTrackableHandle"]
J.SaveTriggerActionHandle = JassCommon["SaveTriggerActionHandle"]
J.SaveTriggerConditionHandle = JassCommon["SaveTriggerConditionHandle"]
J.SaveTriggerEventHandle = JassCommon["SaveTriggerEventHandle"]
J.SaveTriggerHandle = JassCommon["SaveTriggerHandle"]
J.SaveUbersplatHandle = JassCommon["SaveUbersplatHandle"]
J.SaveUnitHandle = JassCommon["SaveUnitHandle"]
J.SaveUnitPoolHandle = JassCommon["SaveUnitPoolHandle"]
J.SaveWidgetHandle = JassCommon["SaveWidgetHandle"]
J.SelectHeroSkill = JassCommon["SelectHeroSkill"]
J.SelectUnit = JassCommon["SelectUnit"]
J.SetAllItemTypeSlots = JassCommon["SetAllItemTypeSlots"]
J.SetAllUnitTypeSlots = JassCommon["SetAllUnitTypeSlots"]
J.SetAllyColorFilterState = JassCommon["SetAllyColorFilterState"]
J.SetAltMinimapIcon = JassCommon["SetAltMinimapIcon"]
J.SetBlight = JassCommon["SetBlight"]
J.SetBlightLoc = JassCommon["SetBlightLoc"]
J.SetBlightPoint = JassCommon["SetBlightPoint"]
J.SetBlightRect = JassCommon["SetBlightRect"]
J.SetCameraBounds = JassCommon["SetCameraBounds"]
J.SetCameraField = JassCommon["SetCameraField"]
J.SetCameraOrientController = JassCommon["SetCameraOrientController"]
J.SetCameraPosition = JassCommon["SetCameraPosition"]
J.SetCameraQuickPosition = JassCommon["SetCameraQuickPosition"]
J.SetCameraRotateMode = JassCommon["SetCameraRotateMode"]
J.SetCameraTargetController = JassCommon["SetCameraTargetController"]
J.SetCampaignAvailable = JassCommon["SetCampaignAvailable"]
J.SetCampaignMenuRace = JassCommon["SetCampaignMenuRace"]
J.SetCampaignMenuRaceEx = JassCommon["SetCampaignMenuRaceEx"]
J.SetCineFilterBlendMode = JassCommon["SetCineFilterBlendMode"]
J.SetCineFilterDuration = JassCommon["SetCineFilterDuration"]
J.SetCineFilterEndColor = JassCommon["SetCineFilterEndColor"]
J.SetCineFilterEndUV = JassCommon["SetCineFilterEndUV"]
J.SetCineFilterStartColor = JassCommon["SetCineFilterStartColor"]
J.SetCineFilterStartUV = JassCommon["SetCineFilterStartUV"]
J.SetCineFilterTexMapFlags = JassCommon["SetCineFilterTexMapFlags"]
J.SetCineFilterTexture = JassCommon["SetCineFilterTexture"]
J.SetCinematicCamera = JassCommon["SetCinematicCamera"]
J.SetCinematicScene = JassCommon["SetCinematicScene"]
J.SetCreatureDensity = JassCommon["SetCreatureDensity"]
J.SetCreepCampFilterState = JassCommon["SetCreepCampFilterState"]
J.SetCustomCampaignButtonVisible = JassCommon["SetCustomCampaignButtonVisible"]
J.SetDayNightModels = JassCommon["SetDayNightModels"]
J.SetDefaultDifficulty = JassCommon["SetDefaultDifficulty"]
J.SetDestructableAnimation = JassCommon["SetDestructableAnimation"]
J.SetDestructableAnimationSpeed = JassCommon["SetDestructableAnimationSpeed"]
J.SetDestructableInvulnerable = JassCommon["SetDestructableInvulnerable"]
J.SetDestructableLife = JassCommon["SetDestructableLife"]
J.SetDestructableMaxLife = JassCommon["SetDestructableMaxLife"]
J.SetDestructableOccluderHeight = JassCommon["SetDestructableOccluderHeight"]
J.SetDoodadAnimation = JassCommon["SetDoodadAnimation"]
J.SetDoodadAnimationRect = JassCommon["SetDoodadAnimationRect"]
J.SetEdCinematicAvailable = JassCommon["SetEdCinematicAvailable"]
J.SetFloatGameState = JassCommon["SetFloatGameState"]
J.SetFogStateRadius = JassCommon["SetFogStateRadius"]
J.SetFogStateRadiusLoc = JassCommon["SetFogStateRadiusLoc"]
J.SetFogStateRect = JassCommon["SetFogStateRect"]
J.SetGameDifficulty = JassCommon["SetGameDifficulty"]
J.SetGamePlacement = JassCommon["SetGamePlacement"]
J.SetGameSpeed = JassCommon["SetGameSpeed"]
J.SetGameTypeSupported = JassCommon["SetGameTypeSupported"]
J.SetHeroAgi = JassCommon["SetHeroAgi"]
J.SetHeroInt = JassCommon["SetHeroInt"]
J.SetHeroLevel = JassCommon["SetHeroLevel"]
J.SetHeroStr = JassCommon["SetHeroStr"]
J.SetHeroXP = JassCommon["SetHeroXP"]
J.SetImageAboveWater = JassCommon["SetImageAboveWater"]
J.SetImageColor = JassCommon["SetImageColor"]
J.SetImageConstantHeight = JassCommon["SetImageConstantHeight"]
J.SetImagePosition = JassCommon["SetImagePosition"]
J.SetImageRender = JassCommon["SetImageRender"]
J.SetImageRenderAlways = JassCommon["SetImageRenderAlways"]
J.SetImageType = JassCommon["SetImageType"]
J.SetIntegerGameState = JassCommon["SetIntegerGameState"]
J.SetIntroShotModel = JassCommon["SetIntroShotModel"]
J.SetIntroShotText = JassCommon["SetIntroShotText"]
J.SetItemCharges = JassCommon["SetItemCharges"]
J.SetItemDropID = JassCommon["SetItemDropID"]
J.SetItemDropOnDeath = JassCommon["SetItemDropOnDeath"]
J.SetItemDroppable = JassCommon["SetItemDroppable"]
J.SetItemInvulnerable = JassCommon["SetItemInvulnerable"]
J.SetItemPawnable = JassCommon["SetItemPawnable"]
J.SetItemPlayer = JassCommon["SetItemPlayer"]
J.SetItemPosition = JassCommon["SetItemPosition"]
J.SetItemTypeSlots = JassCommon["SetItemTypeSlots"]
J.SetItemUserData = JassCommon["SetItemUserData"]
J.SetItemVisible = JassCommon["SetItemVisible"]
J.SetLightningColor = JassCommon["SetLightningColor"]
J.SetMapDescription = JassCommon["SetMapDescription"]
J.SetMapFlag = JassCommon["SetMapFlag"]
J.SetMapMusic = JassCommon["SetMapMusic"]
J.SetMapName = JassCommon["SetMapName"]
J.SetMissionAvailable = JassCommon["SetMissionAvailable"]
J.SetMusicPlayPosition = JassCommon["SetMusicPlayPosition"]
J.SetMusicVolume = JassCommon["SetMusicVolume"]
J.SetOpCinematicAvailable = JassCommon["SetOpCinematicAvailable"]
J.SetPlayerAbilityAvailable = JassCommon["SetPlayerAbilityAvailable"]
J.SetPlayerAlliance = JassCommon["SetPlayerAlliance"]
J.SetPlayerColor = JassCommon["SetPlayerColor"]
J.SetPlayerController = JassCommon["SetPlayerController"]
J.SetPlayerHandicap = JassCommon["SetPlayerHandicap"]
J.SetPlayerHandicapXP = JassCommon["SetPlayerHandicapXP"]
J.SetPlayerName = JassCommon["SetPlayerName"]
J.SetPlayerOnScoreScreen = JassCommon["SetPlayerOnScoreScreen"]
J.SetPlayerRacePreference = JassCommon["SetPlayerRacePreference"]
J.SetPlayerRaceSelectable = JassCommon["SetPlayerRaceSelectable"]
J.SetPlayerStartLocation = JassCommon["SetPlayerStartLocation"]
J.SetPlayerState = JassCommon["SetPlayerState"]
J.SetPlayerTaxRate = JassCommon["SetPlayerTaxRate"]
J.SetPlayerTeam = JassCommon["SetPlayerTeam"]
J.SetPlayerTechMaxAllowed = JassCommon["SetPlayerTechMaxAllowed"]
J.SetPlayerTechResearched = JassCommon["SetPlayerTechResearched"]
J.SetPlayerUnitsOwner = JassCommon["SetPlayerUnitsOwner"]
J.SetPlayers = JassCommon["SetPlayers"]
J.SetRandomSeed = JassCommon["SetRandomSeed"]
J.SetRect = JassCommon["SetRect"]
J.SetRectFromLoc = JassCommon["SetRectFromLoc"]
J.SetReservedLocalHeroButtons = JassCommon["SetReservedLocalHeroButtons"]
J.SetResourceAmount = JassCommon["SetResourceAmount"]
J.SetResourceDensity = JassCommon["SetResourceDensity"]
J.SetSkyModel = JassCommon["SetSkyModel"]
J.SetSoundChannel = JassCommon["SetSoundChannel"]
J.SetSoundConeAngles = JassCommon["SetSoundConeAngles"]
J.SetSoundConeOrientation = JassCommon["SetSoundConeOrientation"]
J.SetSoundDistanceCutoff = JassCommon["SetSoundDistanceCutoff"]
J.SetSoundDistances = JassCommon["SetSoundDistances"]
J.SetSoundDuration = JassCommon["SetSoundDuration"]
J.SetSoundParamsFromLabel = JassCommon["SetSoundParamsFromLabel"]
J.SetSoundPitch = JassCommon["SetSoundPitch"]
J.SetSoundPlayPosition = JassCommon["SetSoundPlayPosition"]
J.SetSoundPosition = JassCommon["SetSoundPosition"]
J.SetSoundVelocity = JassCommon["SetSoundVelocity"]
J.SetSoundVolume = JassCommon["SetSoundVolume"]
J.SetStartLocPrio = JassCommon["SetStartLocPrio"]
J.SetStartLocPrioCount = JassCommon["SetStartLocPrioCount"]
J.SetTeams = JassCommon["SetTeams"]
J.SetTerrainFog = JassCommon["SetTerrainFog"]
J.SetTerrainFogEx = JassCommon["SetTerrainFogEx"]
J.SetTerrainPathable = JassCommon["SetTerrainPathable"]
J.SetTerrainType = JassCommon["SetTerrainType"]
J.SetTextTagAge = JassCommon["SetTextTagAge"]
J.SetTextTagColor = JassCommon["SetTextTagColor"]
J.SetTextTagFadepoint = JassCommon["SetTextTagFadepoint"]
J.SetTextTagLifespan = JassCommon["SetTextTagLifespan"]
J.SetTextTagPermanent = JassCommon["SetTextTagPermanent"]
J.SetTextTagPos = JassCommon["SetTextTagPos"]
J.SetTextTagPosUnit = JassCommon["SetTextTagPosUnit"]
J.SetTextTagSuspended = JassCommon["SetTextTagSuspended"]
J.SetTextTagText = JassCommon["SetTextTagText"]
J.SetTextTagVelocity = JassCommon["SetTextTagVelocity"]
J.SetTextTagVisibility = JassCommon["SetTextTagVisibility"]
J.SetThematicMusicPlayPosition = JassCommon["SetThematicMusicPlayPosition"]
J.SetTimeOfDayScale = JassCommon["SetTimeOfDayScale"]
J.SetTutorialCleared = JassCommon["SetTutorialCleared"]
J.SetUbersplatRender = JassCommon["SetUbersplatRender"]
J.SetUbersplatRenderAlways = JassCommon["SetUbersplatRenderAlways"]
J.SetUnitAbilityLevel = JassCommon["SetUnitAbilityLevel"]
J.SetUnitAcquireRange = JassCommon["SetUnitAcquireRange"]
J.SetUnitAnimation = JassCommon["SetUnitAnimation"]
J.SetUnitAnimationByIndex = JassCommon["SetUnitAnimationByIndex"]
J.SetUnitAnimationWithRarity = JassCommon["SetUnitAnimationWithRarity"]
J.SetUnitBlendTime = JassCommon["SetUnitBlendTime"]
J.SetUnitColor = JassCommon["SetUnitColor"]
J.SetUnitCreepGuard = JassCommon["SetUnitCreepGuard"]
J.SetUnitExploded = JassCommon["SetUnitExploded"]
J.SetUnitFacing = JassCommon["SetUnitFacing"]
J.SetUnitFacingTimed = JassCommon["SetUnitFacingTimed"]
J.SetUnitFlyHeight = JassCommon["SetUnitFlyHeight"]
J.SetUnitFog = JassCommon["SetUnitFog"]
J.SetUnitInvulnerable = JassCommon["SetUnitInvulnerable"]
J.SetUnitLookAt = JassCommon["SetUnitLookAt"]
J.SetUnitMoveSpeed = JassCommon["SetUnitMoveSpeed"]
J.SetUnitOwner = JassCommon["SetUnitOwner"]
J.SetUnitPathing = JassCommon["SetUnitPathing"]
J.SetUnitPosition = JassCommon["SetUnitPosition"]
J.SetUnitPositionLoc = JassCommon["SetUnitPositionLoc"]
J.SetUnitPropWindow = JassCommon["SetUnitPropWindow"]
J.SetUnitRescuable = JassCommon["SetUnitRescuable"]
J.SetUnitRescueRange = JassCommon["SetUnitRescueRange"]
J.SetUnitScale = JassCommon["SetUnitScale"]
J.SetUnitState = JassCommon["SetUnitState"]
J.SetUnitTimeScale = JassCommon["SetUnitTimeScale"]
J.SetUnitTurnSpeed = JassCommon["SetUnitTurnSpeed"]
J.SetUnitTypeSlots = JassCommon["SetUnitTypeSlots"]
J.SetUnitUseFood = JassCommon["SetUnitUseFood"]
J.SetUnitUserData = JassCommon["SetUnitUserData"]
J.SetUnitVertexColor = JassCommon["SetUnitVertexColor"]
J.SetUnitX = JassCommon["SetUnitX"]
J.SetUnitY = JassCommon["SetUnitY"]
J.SetWaterBaseColor = JassCommon["SetWaterBaseColor"]
J.SetWaterDeforms = JassCommon["SetWaterDeforms"]
J.SetWidgetLife = JassCommon["SetWidgetLife"]
J.ShowDestructable = JassCommon["ShowDestructable"]
J.ShowImage = JassCommon["ShowImage"]
J.ShowInterface = JassCommon["ShowInterface"]
J.ShowUbersplat = JassCommon["ShowUbersplat"]
J.ShowUnit = JassCommon["ShowUnit"]
J.Sin = JassCommon["Sin"]
J.SquareRoot = JassCommon["SquareRoot"]
J.StartCampaignAI = JassCommon["StartCampaignAI"]
J.StartMeleeAI = JassCommon["StartMeleeAI"]
J.StartSound = JassCommon["StartSound"]
J.StopCamera = JassCommon["StopCamera"]
J.StopMusic = JassCommon["StopMusic"]
J.StopSound = JassCommon["StopSound"]
J.StoreBoolean = JassCommon["StoreBoolean"]
J.StoreInteger = JassCommon["StoreInteger"]
J.StoreReal = JassCommon["StoreReal"]
J.StoreString = JassCommon["StoreString"]
J.StoreUnit = JassCommon["StoreUnit"]
J.StringCase = JassCommon["StringCase"]
J.StringHash = JassCommon["StringHash"]
J.StringLength = JassCommon["StringLength"]
J.SubString = JassCommon["SubString"]
J.SuspendHeroXP = JassCommon["SuspendHeroXP"]
J.SuspendTimeOfDay = JassCommon["SuspendTimeOfDay"]
J.SyncSelections = JassCommon["SyncSelections"]
J.SyncStoredBoolean = JassCommon["SyncStoredBoolean"]
J.SyncStoredInteger = JassCommon["SyncStoredInteger"]
J.SyncStoredReal = JassCommon["SyncStoredReal"]
J.SyncStoredString = JassCommon["SyncStoredString"]
J.SyncStoredUnit = JassCommon["SyncStoredUnit"]
J.Tan = JassCommon["Tan"]
J.TerrainDeformCrater = JassCommon["TerrainDeformCrater"]
J.TerrainDeformRandom = JassCommon["TerrainDeformRandom"]
J.TerrainDeformRipple = JassCommon["TerrainDeformRipple"]
J.TerrainDeformStop = JassCommon["TerrainDeformStop"]
J.TerrainDeformStopAll = JassCommon["TerrainDeformStopAll"]
J.TerrainDeformWave = JassCommon["TerrainDeformWave"]
J.TimerDialogDisplay = JassCommon["TimerDialogDisplay"]
J.TimerDialogSetRealTimeRemaining = JassCommon["TimerDialogSetRealTimeRemaining"]
J.TimerDialogSetSpeed = JassCommon["TimerDialogSetSpeed"]
J.TimerDialogSetTimeColor = JassCommon["TimerDialogSetTimeColor"]
J.TimerDialogSetTitle = JassCommon["TimerDialogSetTitle"]
J.TimerDialogSetTitleColor = JassCommon["TimerDialogSetTitleColor"]
J.TimerGetElapsed = JassCommon["TimerGetElapsed"]
J.TimerGetRemaining = JassCommon["TimerGetRemaining"]
J.TimerGetTimeout = JassCommon["TimerGetTimeout"]
J.TimerStart = JassCommon["TimerStart"]
J.TriggerAddAction = JassCommon["TriggerAddAction"]
J.TriggerAddCondition = JassCommon["TriggerAddCondition"]
J.TriggerClearActions = JassCommon["TriggerClearActions"]
J.TriggerClearConditions = JassCommon["TriggerClearConditions"]
J.TriggerEvaluate = JassCommon["TriggerEvaluate"]
J.TriggerExecute = JassCommon["TriggerExecute"]
J.TriggerExecuteWait = JassCommon["TriggerExecuteWait"]
J.TriggerRegisterDeathEvent = JassCommon["TriggerRegisterDeathEvent"]
J.TriggerRegisterDialogButtonEvent = JassCommon["TriggerRegisterDialogButtonEvent"]
J.TriggerRegisterDialogEvent = JassCommon["TriggerRegisterDialogEvent"]
J.TriggerRegisterEnterRegion = JassCommon["TriggerRegisterEnterRegion"]
J.TriggerRegisterFilterUnitEvent = JassCommon["TriggerRegisterFilterUnitEvent"]
J.TriggerRegisterGameEvent = JassCommon["TriggerRegisterGameEvent"]
J.TriggerRegisterGameStateEvent = JassCommon["TriggerRegisterGameStateEvent"]
J.TriggerRegisterLeaveRegion = JassCommon["TriggerRegisterLeaveRegion"]
J.TriggerRegisterPlayerAllianceChange = JassCommon["TriggerRegisterPlayerAllianceChange"]
J.TriggerRegisterPlayerChatEvent = JassCommon["TriggerRegisterPlayerChatEvent"]
J.TriggerRegisterPlayerEvent = JassCommon["TriggerRegisterPlayerEvent"]
J.TriggerRegisterPlayerStateEvent = JassCommon["TriggerRegisterPlayerStateEvent"]
J.TriggerRegisterPlayerUnitEvent = JassCommon["TriggerRegisterPlayerUnitEvent"]
J.TriggerRegisterTimerEvent = JassCommon["TriggerRegisterTimerEvent"]
J.TriggerRegisterTimerExpireEvent = JassCommon["TriggerRegisterTimerExpireEvent"]
J.TriggerRegisterTrackableHitEvent = JassCommon["TriggerRegisterTrackableHitEvent"]
J.TriggerRegisterTrackableTrackEvent = JassCommon["TriggerRegisterTrackableTrackEvent"]
J.TriggerRegisterUnitEvent = JassCommon["TriggerRegisterUnitEvent"]
J.TriggerRegisterUnitInRange = JassCommon["TriggerRegisterUnitInRange"]
J.TriggerRegisterUnitStateEvent = JassCommon["TriggerRegisterUnitStateEvent"]
J.TriggerRegisterVariableEvent = JassCommon["TriggerRegisterVariableEvent"]
J.TriggerRemoveAction = JassCommon["TriggerRemoveAction"]
J.TriggerRemoveCondition = JassCommon["TriggerRemoveCondition"]
J.TriggerSleepAction = JassCommon["TriggerSleepAction"]
J.TriggerSyncReady = JassCommon["TriggerSyncReady"]
J.TriggerSyncStart = JassCommon["TriggerSyncStart"]
J.TriggerWaitForSound = JassCommon["TriggerWaitForSound"]
J.TriggerWaitOnSleeps = JassCommon["TriggerWaitOnSleeps"]
J.UnitAddAbility = JassCommon["UnitAddAbility"]
J.UnitAddIndicator = JassCommon["UnitAddIndicator"]
J.UnitAddItem = JassCommon["UnitAddItem"]
J.UnitAddItemById = JassCommon["UnitAddItemById"]
J.UnitAddItemToSlotById = JassCommon["UnitAddItemToSlotById"]
J.UnitAddSleep = JassCommon["UnitAddSleep"]
J.UnitAddSleepPerm = JassCommon["UnitAddSleepPerm"]
J.UnitAddType = JassCommon["UnitAddType"]
J.UnitApplyTimedLife = JassCommon["UnitApplyTimedLife"]
J.UnitCanSleep = JassCommon["UnitCanSleep"]
J.UnitCanSleepPerm = JassCommon["UnitCanSleepPerm"]
J.UnitCountBuffsEx = JassCommon["UnitCountBuffsEx"]
J.UnitDamagePoint = JassCommon["UnitDamagePoint"]
J.UnitDamageTarget = JassCommon["UnitDamageTarget"]
J.UnitDropItemPoint = JassCommon["UnitDropItemPoint"]
J.UnitDropItemSlot = JassCommon["UnitDropItemSlot"]
J.UnitDropItemTarget = JassCommon["UnitDropItemTarget"]
J.UnitHasBuffsEx = JassCommon["UnitHasBuffsEx"]
J.UnitHasItem = JassCommon["UnitHasItem"]
J.UnitId = JassCommon["UnitId"]
J.UnitId2String = JassCommon["UnitId2String"]
J.UnitIgnoreAlarm = JassCommon["UnitIgnoreAlarm"]
J.UnitIgnoreAlarmToggled = JassCommon["UnitIgnoreAlarmToggled"]
J.UnitInventorySize = JassCommon["UnitInventorySize"]
J.UnitIsSleeping = JassCommon["UnitIsSleeping"]
J.UnitItemInSlot = JassCommon["UnitItemInSlot"]
J.UnitMakeAbilityPermanent = JassCommon["UnitMakeAbilityPermanent"]
J.UnitModifySkillPoints = JassCommon["UnitModifySkillPoints"]
J.UnitPauseTimedLife = JassCommon["UnitPauseTimedLife"]
J.UnitPoolAddUnitType = JassCommon["UnitPoolAddUnitType"]
J.UnitPoolRemoveUnitType = JassCommon["UnitPoolRemoveUnitType"]
J.UnitRemoveAbility = JassCommon["UnitRemoveAbility"]
J.UnitRemoveBuffs = JassCommon["UnitRemoveBuffs"]
J.UnitRemoveBuffsEx = JassCommon["UnitRemoveBuffsEx"]
J.UnitRemoveItem = JassCommon["UnitRemoveItem"]
J.UnitRemoveItemFromSlot = JassCommon["UnitRemoveItemFromSlot"]
J.UnitRemoveType = JassCommon["UnitRemoveType"]
J.UnitResetCooldown = JassCommon["UnitResetCooldown"]
J.UnitSetConstructionProgress = JassCommon["UnitSetConstructionProgress"]
J.UnitSetUpgradeProgress = JassCommon["UnitSetUpgradeProgress"]
J.UnitSetUsesAltIcon = JassCommon["UnitSetUsesAltIcon"]
J.UnitShareVision = JassCommon["UnitShareVision"]
J.UnitStripHeroLevel = JassCommon["UnitStripHeroLevel"]
J.UnitSuspendDecay = JassCommon["UnitSuspendDecay"]
J.UnitUseItem = JassCommon["UnitUseItem"]
J.UnitUseItemPoint = JassCommon["UnitUseItemPoint"]
J.UnitUseItemTarget = JassCommon["UnitUseItemTarget"]
J.UnitWakeUp = JassCommon["UnitWakeUp"]
J.UnregisterStackedSound = JassCommon["UnregisterStackedSound"]
J.VersionCompatible = JassCommon["VersionCompatible"]
J.VersionGet = JassCommon["VersionGet"]
J.VersionSupported = JassCommon["VersionSupported"]
J.VolumeGroupReset = JassCommon["VolumeGroupReset"]
J.VolumeGroupSetVolume = JassCommon["VolumeGroupSetVolume"]
J.WaygateActivate = JassCommon["WaygateActivate"]
J.WaygateGetDestinationX = JassCommon["WaygateGetDestinationX"]
J.WaygateGetDestinationY = JassCommon["WaygateGetDestinationY"]
J.WaygateIsActive = JassCommon["WaygateIsActive"]
J.WaygateSetDestination = JassCommon["WaygateSetDestination"]

math.sin = J.Sin
math.cos = J.Cos
math.tan = J.Tan
math.asin = J.Asin
math.acos = J.Acos
math.atan = J.Atan2

local cic = { c2i = {}, i2c = {} }

--- 字符ID转整型ID
---@param idChar string
---@return number
function c2i(idChar)
    must(type(idChar) == "string", "c2i")
    local id = cic.c2i[idChar]
    if (id == nil) then
        id = ('>I4'):unpack(idChar)
        cic.c2i[idChar] = id
        cic.i2c[id] = idChar
    end
    return id
end

--- 整型ID转字符ID
---@param id number
---@return string
function i2c(id)
    must(type(id) == "number", "i2c")
    local idChar = cic.i2c[id]
    if (idChar == nil) then
        idChar = ('>I4'):pack(id)
        cic.i2c[id] = idChar
        cic.c2i[idChar] = id
    end
    return idChar
end

--- 保证
---@param execute function
---@param fail function|nil 失败后执行
---@param done function|nil 成功后执行
---@vararg any 参
---@return boolean
function promise(execute, fail, done, ...)
    local result = true
    if (type(execute) == "function") then
        local e
        result, e = xpcall(execute, debug.traceback, ...)
        if (result == true) then
            if (type(done) == "function") then
                done()
            end
        else
            print(e)
            if (type(fail) == "function") then
                fail()
            end
        end
    end
    return result
end